%This script is an interface to the script mix2_main. 
function start_mix2( string_grouptyingfile , string_validityfile , string_previousparams , string_configfile, trans_defs_file , sample_file , nr_blocks , output_file , nr_initializations , nr_fragments_experiment );

	if nargin < 1
		error('usage: start_mix2_pairedend(<groups_file>|0 <transcript_specific_ss_lengths_and_validity_matrix_file>|0 <previousparams_file>|0 <config_file> <trans_def_file> <sample_file> <nr_blocks> <output_file> [<nr_initializations> <nr_fragments_experiment>])\n');
	end

	if !string_grouptyingfile
		string_grouptyingfile = "";	%This string holds the location of the grouptying file OR is left blank
	end

	if !string_validityfile
		string_validityfile = "";	%This string holds the location of the validity_matrices file OR is left blank
	end

	if !string_previousparams
		string_previousparams = "";	%This string holds the location of the .sav file with estimation results of a previous estimation run OR is left blank
	end

	if ischar(nr_blocks)
		nr_blocks = round(eval(sprintf("%s",nr_blocks)));	%This scalar is the number of 'block' functions that are used to model the distribution of fragment startsites over the length of a transcript
	end

	if nargin < 8
		output_file = "./ems_init_var.sav"; %This string holds the location of the .sav file. It is either filled by the user or set to "./ems_init_var.sav"
	end

	if nargin < 9	
		nr_initializations = 1;	%This scalar is the number of initializations for the EM algorithm. 
	end
	
	if nargin < 10
		nr_fragments_experiment = 1;	%This scalar is the number of fragments present in the whole experiment. This Mix² model implementation handles a single gene and uses this number of fragments to calculate the FPKM value for each transcript.
	end

	mix2_main( string_grouptyingfile , string_validityfile , string_previousparams , string_configfile, trans_defs_file , sample_file , nr_blocks , output_file , nr_initializations , nr_fragments_experiment ) ;
	
end
