function [trans_groups  trans_length_groups] = tie_trans_length(trans_lengths, max_nr_groups, valid_frags, min_frags_group, max_nr_single_groups, initial_groups)
	if nargin < 2
		max_nr_groups = Inf;
	end
	if nargin < 3
		valid_frags = zeros(1, length(trans_lengths));
	end
	if nargin < 4
		min_frags_group = 0;
	end
	if nargin < 5
		max_nr_single_groups = 1;
	end
	nr_trans = length(trans_lengths);
	if nargin < 6
		for ii=1:nr_trans
			trans_groups{ii}=ii;
			trans_group_frags(ii)=valid_frags(ii);
		end
	else
		nr_initial_groups = length(initial_groups)-1;
		gr = 0;
		for ii=1:nr_initial_groups
			ind = find(trans_lengths > initial_groups(ii) & trans_lengths <= initial_groups(ii+1));
			if(length(ind) > 0)
				gr++;
				trans_groups{gr} = ind;
				trans_group_frags(gr) = sum(valid_frags(trans_groups{gr}));
			end
		end
	end
	while 1 %merge elements into groups
		if ((length(find(cellfun(@length, trans_groups) == 1))<= max_nr_single_groups && length(trans_groups) <= max_nr_groups && min(trans_group_frags) >= min_frags_group) || (length(trans_groups) == 1))
			break;
		end
		nr_groups = length(trans_groups);
		groups_dist = Inf*ones(nr_groups, nr_groups);
		for gr1=1:nr_groups
			for gr2=[gr1+1:nr_groups]
				groups_dist(gr1,gr2) = group_dist(trans_lengths(trans_groups{gr1}),trans_lengths(trans_groups{gr2}));
			end
		end
		[m1 mi1] = min(groups_dist);
		[m2 mi2] = min(min(groups_dist));
		min_dist_group1 = mi1(mi2);
		min_dist_group2 = mi2;
		trans_groups{min_dist_group2}(end+1:end+length(trans_groups{min_dist_group1})) = trans_groups{min_dist_group1};
		trans_group_frags(min_dist_group2) += trans_group_frags(min_dist_group1);
		trans_groups(min_dist_group1) = [];
		trans_group_frags(min_dist_group1) = [];
	end
	for ii=1:length(trans_groups)
		trans_length_groups{ii} = trans_lengths(trans_groups{ii});
	end
endfunction

function dist = group_dist(group1, group2)
	mean_group1 = mean(group1);
	mean_group2 = mean(group2);
	dist = scale_dist(mean_group1, mean_group2)*abs(mean_group1-mean_group2);
endfunction

function scale = scale_dist(mean_group1, mean_group2)
	scale = 1/abs(100-min(mean_group1,mean_group2));
endfunction
