function [ reads_single, single_nr_exoncoords , fragment_ids_single, reads_paired , paired_nr_exoncoords , fragment_ids_paired , totalcount ] = util_extract_reads( filename , nr_exon_positions )
	warning("off");
	%READING
	single_nr_exoncoords=[];
	paired_nr_exoncoords{1}=[];
	paired_nr_exoncoords{2}=[];
	ic_single=0;
	ic_paired=0;
	in_count=0;
	maxcol=max(nr_exon_positions);
	clear strcell;
	pair_dict = struct;
	paircriteria = bitget(1,[1:8]);
	reads_single = zeros(1,maxcol);
	reads_paired{1} = zeros(1,maxcol);
	reads_paired{2} = zeros(1,maxcol);
	reads_drain = zeros(1,maxcol);
	fid=fopen(filename,"r");
	while ( 1 )	
		if strcmp( fscanf(fid,"%c",1) , "@" )
			fgetl(fid);
			continue;
		end
		++in_count;
		[ QNAME , flag_dec , RNAME , POS , MAPQ , CIGAR , RNEXT , PNEXT , TLEN , SEQ ] = fscanf(fid,"%s\t%d\t%s\t%d\t%d\t%s\t%s\t%d\t%s\t%s","C");
		fgetl(fid);
		if isempty(QNAME)
			break	
		end
		flag = bitget( flag_dec ,[1:8] );
		read = cigar2read( CIGAR ) + POS;
		nr_exon_positions = length(read);
		%take flag and determine status
		if(all ( paircriteria == ( (flag & paircriteria) ) ))	%is pair?
		%yes : read is paired end read
			md5ids = ["md5",md5sum(QNAME,1)];
			%checking if a pairmate is present already in the registry
			if ( isfield( pair_dict , md5ids ) )
			% The id was part of the pair_dict structure; hence the read pair is complete
				refindex = getfield( pair_dict , md5ids );
				if ( (read(1) <= reads_drain ( refindex , 1)) && (read(nr_exon_positions) <= reads_drain ( refindex , exoncoords_drain(refindex) )) )
					reads_paired{1}( refindex , 1:nr_exon_positions ) = read;
					reads_paired{2}( refindex , 1:exoncoords_drain ( refindex ) ) = reads_drain ( refindex , 1 : exoncoords_drain ( refindex ) );
					paired_nr_exoncoords{1}(refindex,1) = nr_exon_positions;
					paired_nr_exoncoords{2}(refindex,1) = exoncoords_drain ( refindex );
				else
					reads_paired{2}( refindex , 1:nr_exon_positions ) = read;
					reads_paired{1}( refindex , 1:exoncoords_drain ( refindex ) ) = reads_drain ( refindex , 1 : exoncoords_drain ( refindex ) );
					paired_nr_exoncoords{2}(refindex,1) = nr_exon_positions;
					paired_nr_exoncoords{1}(refindex,1) = exoncoords_drain ( refindex );
				end
				fragment_ids_paired{ refindex } = QNAME;				
			else
			% The id is not part of the pair_dict structure : this is the first read of a read pair
				ic_paired++;
				pair_dict.(md5ids) = ic_paired;
				reads_drain( ic_paired , 1:nr_exon_positions ) = read;
				exoncoords_drain ( ic_paired ) = nr_exon_positions;
			end
		else
		%no : read is single end read
			ic_single++;
			reads_single( ic_single , 1:nr_exon_positions ) = read ;
			fragment_ids_single{ ic_single } = QNAME;
			single_nr_exoncoords (ic_single,1) = nr_exon_positions;
		end
	end
	fclose(fid);
	%ic_paired reset : erasing incomplete entries ( missing pair mate result into gaps and/or a wrong ic_paired count )
	if( !isempty(paired_nr_exoncoords{1}) )
		index_incomplete = paired_nr_exoncoords{1}==0;
		if(any(index_incomplete))
			reads_paired{ 1 }( index_incomplete,: ) = [];
			reads_paired{ 2 }( index_incomplete,: ) = [];
			fragment_ids_paired( index_incomplete ) = [];
			paired_nr_exoncoords{1}(index_incomplete) = [];
			paired_nr_exoncoords{2}(index_incomplete) = [];
			ic_paired = size(fragment_ids_paired,2);
		end
	end
	totalcount = ic_single + ic_paired;
end

#function read = cigar2read( cigar )
#	numcigar = cigar + 0;
#	stsi = sum(numcigar > ("9"+0)); 	% # of Characters 

#	cc=1;
#	read(cc)=0;
#	stack=0;

#	for jj = 1:stsi
#		[v01,v02] = sscanf(cigar,"%d%c","C");

#		if (v02+0 == 78)
#			%stack -> exon position
#			++cc;
#			read(cc) = stack + read(cc-1) - 1;
#			stack=0;
#			++cc;
#			read(cc) = read(cc-1) + v01 +1;
#		elseif ( v02+0  == 73)
#			%Insertion handling
#			
#			%Do nothing

#			%Yep, that's it. Insertions are not counted towards the total length of the read

#		elseif jj != stsi
#			stack += v01;
#		else
#			%last position	
#			++cc;
#			read(cc) = read(cc-1) + stack+ v01 -1;
#		end

#		dis=length( (sprintf("%d",v01).+0) ) + 1;
#		cigar(1:dis)=[];
#	end
#end
